aubio 0.4.9

Loading...
Searching...
No Matches
source.h
Go to the documentation of this file.
1/*
2 Copyright (C) 2012-2013 Paul Brossier <piem@aubio.org>
3
4 This file is part of aubio.
5
6 aubio is free software: you can redistribute it and/or modify
7 it under the terms of the GNU General Public License as published by
8 the Free Software Foundation, either version 3 of the License, or
9 (at your option) any later version.
10
11 aubio is distributed in the hope that it will be useful,
12 but WITHOUT ANY WARRANTY; without even the implied warranty of
13 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 GNU General Public License for more details.
15
16 You should have received a copy of the GNU General Public License
17 along with aubio. If not, see <http://www.gnu.org/licenses/>.
18
19*/
20
21#ifndef AUBIO_SOURCE_H
22#define AUBIO_SOURCE_H
23
24/** \file
25
26 Media source to read blocks of consecutive audio samples from file.
27
28 To write to file, use ::aubio_sink_t.
29
30 Depending on how aubio was compiled, the following sources will be available.
31
32 When creating a new source using ::new_aubio_source, the new function of each
33 of the compiled-in sources will be used, in the following order, until one of
34 them gets successfully created. If all sources returned NULL,
35 ::new_aubio_source will return NULL.
36
37 \b \p source_avcodec : libav
38
39 aubio can be optionally compiled with [libav](http://libav.org), which can
40 read from a very large number of audio and video formats, including over
41 different network protocols such as HTTP.
42
43 \b \p source_apple_audio : ExtAudioFileRef
44
45 On Mac and iOS platforms, aubio should be compiled with CoreAudio [Extended
46 Audio File Services]
47 (https://developer.apple.com/library/mac/documentation/MusicAudio/Reference/ExtendedAudioFileServicesReference/Reference/reference.html).
48 This provides access to most common audio file formats, including compressed
49 ones.
50
51 \b \p source_sndfile : libsndfile
52
53 Also optional, aubio can be built against
54 [libsndfile](http://www.mega-nerd.com/libsndfile/), which can read [most
55 uncompressed formats](http://www.mega-nerd.com/libsndfile/#Features).
56
57 \b \p source_wavread : native WAV reader
58
59 A simple source to read from 16-bits PCM RIFF encoded WAV files.
60
61 \example io/test-source.c
62
63*/
64
65#ifdef __cplusplus
66 extern "C" {
67#endif
68
69/** media source object */
70 typedef struct _aubio_source_t aubio_source_t;
71
72/**
73
74 create new ::aubio_source_t
75
76 \param uri the file path or uri to read from
77 \param samplerate sampling rate to view the fie at
78 \param hop_size the size of the blocks to read from
79
80 Creates a new source object. If `0` is passed as `samplerate`, the sample
81 rate of the original file is used.
82
83 The samplerate of newly created source can be obtained using
84 ::aubio_source_get_samplerate.
85
86*/
87 aubio_source_t * new_aubio_source(const char_t * uri, uint_t samplerate, uint_t hop_size);
88
89/**
90
91 read monophonic vector of length hop_size from source object
92
93 \param s source object, created with ::new_aubio_source
94 \param read_to ::fvec_t of data to read to
95 \param read upon returns, equals to number of frames actually read
96
97 Upon returns, `read` contains the number of frames actually read from the
98 source. `hop_size` if enough frames could be read, less otherwise.
99
100*/
101 void aubio_source_do(aubio_source_t * s, fvec_t * read_to, uint_t * read);
102
103/**
104
105 read polyphonic vector of length hop_size from source object
106
107 \param s source object, created with ::new_aubio_source
108 \param read_to ::fmat_t of data to read to
109 \param[out] read upon returns, equals to number of frames actually read
110
111 Upon returns, `read` contains the number of frames actually read from the
112 source. `hop_size` if enough frames could be read, less otherwise.
113
114*/
115 void aubio_source_do_multi(aubio_source_t * s, fmat_t * read_to, uint_t * read);
116
117/**
118
119 get samplerate of source object
120
121 \param s source object, created with ::new_aubio_source
122 \return samplerate, in Hz
123
124*/
125 uint_t aubio_source_get_samplerate(aubio_source_t * s);
126
127/**
128
129 get channels of source object
130
131 \param s source object, created with ::new_aubio_source
132 \return channels
133
134*/
135 uint_t aubio_source_get_channels (aubio_source_t * s);
136
137/**
138
139 seek source object
140
141 \param s source object, created with ::new_aubio_source
142 \param pos position to seek to, in frames
143
144 \return 0 if sucessful, non-zero on failure
145
146*/
147 uint_t aubio_source_seek (aubio_source_t * s, uint_t pos);
148
149/**
150
151 get the duration of source object, in frames
152
153 \param s source object, created with ::new_aubio_source
154 \return number of frames in file
155
156*/
157 uint_t aubio_source_get_duration (aubio_source_t * s);
158
159/**
160
161 close source object
162
163 \param s source object, created with ::new_aubio_source
164
165 \return 0 if sucessful, non-zero on failure
166
167 */
168 uint_t aubio_source_close (aubio_source_t *s);
169
170/**
171
172 close source and cleanup memory
173
174 \param s source object, created with ::new_aubio_source
175
176*/
177 void del_aubio_source(aubio_source_t * s);
178
179#ifdef __cplusplus
180}
181#endif
182
183#endif /* AUBIO_SOURCE_H */
aubio_source_get_samplerate
uint_t aubio_source_get_samplerate(aubio_source_t *s)
get samplerate of source object
aubio_source_get_channels
uint_t aubio_source_get_channels(aubio_source_t *s)
get channels of source object
aubio_source_t
struct _aubio_source_t aubio_source_t
media source object
Definition: source.h:70
new_aubio_source
aubio_source_t * new_aubio_source(const char_t *uri, uint_t samplerate, uint_t hop_size)
create new aubio_source_t
aubio_source_get_duration
uint_t aubio_source_get_duration(aubio_source_t *s)
get the duration of source object, in frames
aubio_source_do_multi
void aubio_source_do_multi(aubio_source_t *s, fmat_t *read_to, uint_t *read)
read polyphonic vector of length hop_size from source object
del_aubio_source
void del_aubio_source(aubio_source_t *s)
close source and cleanup memory
aubio_source_close
uint_t aubio_source_close(aubio_source_t *s)
close source object
aubio_source_seek
uint_t aubio_source_seek(aubio_source_t *s, uint_t pos)
seek source object
aubio_source_do
void aubio_source_do(aubio_source_t *s, fvec_t *read_to, uint_t *read)
read monophonic vector of length hop_size from source object
fmat_t
Buffer for real data.
Definition: fmat.h:40
fvec_t
Buffer for real data.
Definition: fvec.h:67
uint_t
unsigned int uint_t
unsigned integer
Definition: types.h:60
char_t
char char_t
character
Definition: types.h:64